import logging
import time
import datetime
import random
import math


logging.basicConfig(filename=f"Anlagendaten\AnlagenLogfile.log", level=logging.DEBUG, format="%(message)s")

simulierteTage = 5
aktuelleZeit = time.time()
zeit = aktuelleZeit - (simulierteTage * 24 * 60 * 60)

while zeit < aktuelleZeit:
    # box müller standard deviated
    pmpp = round(5.7 * math.pow(abs(math.sqrt(-2.0 * math.log((1 - random.random()))) * math.sin(2.0 * math.pi * (1.0 - random.random()))), 0.03), 3)
    qualität = "A"
    if pmpp < 5.2:
        qualität = "B"
    zeitstempel = datetime.datetime.fromtimestamp(zeit).replace(microsecond=0)

    logging.debug(f"{zeitstempel};{pmpp};{qualität}")
    #print(f"{zeitstempel};{pmpp};{qualität}")

    zeit += random.uniform(50, 59)
