import statistics

# Listen
# Sammlung von Elementen

# Leere Liste erstellen
listeLeer = []
print(listeLeer)
print(type(listeLeer))

# Liste von Strings, Integers, Floats, Listen
listeVonStrings = ["a", "b", "c"]
print(listeVonStrings)
listeVonIntegers = [9, 21, 0, 1, 2, 3, 4, 5, 6, 7]
print(listeVonIntegers)
listeVonFloats = [1.1, 2.2, 3.3, 4.4, 5.5]
print(listeVonFloats)
listeVonListen = [[1, 3], [3, 7]]	# Auch als Array bekannt
print(listeVonListen)

# Elemente anhängen
listeVonIntegers.append(9)      # Element an Ende der Liste anhängen
print(listeVonIntegers)
listeVonIntegers.insert(2, 8)   # Element an indizierte Stelle der Liste anhängen liste.append(Index, Element)
print(listeVonIntegers)
print(listeVonIntegers + [10, 11, 12, 13])	# Listen verknüpfen

# Elemente einer Liste auslesen uns anpassen - liste[Start:Ende]
print(listeVonIntegers[0])      # erstes Element
listeVonIntegers[0] = 99		# Überschreibt den Wert an der Stelle mit Index 0 mit dem Wert 99
print(listeVonIntegers[0])
print(listeVonIntegers[-1])     # letztes Element
print(listeVonIntegers[2])      # Element an indizierter Stelle (3. Element)
print(listeVonIntegers[1:3])    # Elemente von Start (einschließlich) bis Ende (ausschließlich)
print(listeVonIntegers[:3])     # Elemente von Start bis Ende (ausschließlich)
print(listeVonIntegers[2:])     # Elemente von Start (einschließlich) bis Ende

# Elemente entfernen
listeVonIntegers.remove(7)                      # erstes Element mit Wert 7 entfernen
print(listeVonIntegers)
listeVonIntegers.remove(listeVonIntegers[1])    # Element mit Index 1 entfernen
print(listeVonIntegers)
print(listeVonIntegers.pop())                   # entfernt und gibt das letzte Element der Liste zurück
print(listeVonIntegers)

# Interessante Kennzahlen einer Liste
print(len(listeVonIntegers))					# Anzahl der Elemente
print(min(listeVonIntegers))					# Minimalwert
print(max(listeVonIntegers))					# Maximalwert
print(sum(listeVonIntegers))					# Summe
print(statistics.mean(listeVonIntegers))		# Durchschnitt
print(statistics.median(listeVonIntegers))		# Median
print(statistics.stdev(listeVonIntegers))		# Standardabweichung
print(statistics.variance(listeVonIntegers))	# Varianz

# Methoden für Listen
print(listeVonIntegers.index(2))    # gibt Index von erstem Element mit Wert 2 zurück
print(listeVonIntegers.count(9))    # gibt Anzahl von Elementen mit Wert 9 zurück
listeVonIntegers.sort()             # sortiert Elemente der Liste (aufsteigend)
print(listeVonIntegers)
listeVonIntegers.reverse()          # kehrt Reihenfolge der Elemente in der Liste um
print(listeVonIntegers)

# prüfen ob Liste einen bestimmten Wert enthält
print(21 in listeVonIntegers)
print(0 in listeVonIntegers)

# Schleifendurchlauf durch alle Elemente in einer Liste
for element in listeVonIntegers:
	print(element)

# Liste kopieren
print(listeVonIntegers)

# 1) Referenz auf bereits bestehende Liste erstellen
kopierteListe = listeVonIntegers
kopierteListe.append(99)
print(kopierteListe)
print(listeVonIntegers)

# 2) Kopie einer bereits bestehenden Liste erstellen
kopierteListe2 = listeVonIntegers[:]
kopierteListe2.append(77)
print(kopierteListe2)
print(listeVonIntegers)
