import os
from shutil import copy2

quellOrdner = r".\Anlagendaten"
zielOrdner = r".\ZuProzessieren"

# Schleife über alle Dateien in einem Ordner und allen Unterordnern
for pfad, unterverzeichnisse, dateien in os.walk(quellOrdner):
    for datei in dateien:
        # Pfad und Dateinamen kombinieren
        quelle = os.path.join(pfad, datei)
        ziel = quelle.replace(quellOrdner, zielOrdner)

        # Zielverzeichnis erstellen falls es noch nicht existiert
        if not os.path.exists(os.path.dirname(ziel)):
            os.makedirs(os.path.dirname(ziel))
        
        # Datei kopieren
        copy2(quelle, ziel)
