import os
from shutil import copy2

quellOrdner = r".\Anlagendaten"
zielOrdner = r".\ZuProzessieren"

for pfad, unterverzeichnisse, dateien in os.walk(quellOrdner):
    for datei in dateien:
        quelle = os.path.join(pfad, datei)
        ziel = quelle.replace(quellOrdner, zielOrdner)

        if not os.path.exists(os.path.dirname(ziel)):
            os.makedirs(os.path.dirname(ziel))

        copy2(quelle, ziel)
