import time
import random

# Überflüssige Operationen vermeiden

# Geschachtelte Schleifen vermeiden
x = 0
avgZeitI, avgZeitK, avgZeitM = 0, 0, 0
startZeitI = time.time()
for i in range(10):
	time.sleep(0.001)

	startZeitK = time.time()
	for k in range(10):
		time.sleep(0.001)

		startZeitM = time.time()
		for m in range(10):
			time.sleep(0.001)	

		avgZeitM = (k * avgZeitM + time.time() - startZeitM) / (k + 1)
	avgZeitK = (i * avgZeitK + time.time() - startZeitK) / (i + 1)	
avgZeitI = (x * avgZeitI + time.time() - startZeitI) / (x + 1)
x += 1

print(f"m: {avgZeitM}; k: {avgZeitK}; i: {avgZeitI}")
print("---")


# Listen Sortieren
liste = [i for i in range(5000000)]
random.shuffle(liste)

for i in range(5):
	startZeit = time.time()
	if random.randint(0, 5000000) in liste:
		print(time.time() - startZeit)

liste.sort()
for i in range(5):
	startZeit = time.time()
	if random.randint(0, 5000000) in liste:
		print(time.time() - startZeit)

print("---")


# Dictionaries verwenden
liste = [i for i in range(5000000)]
dictionary = {i: None for i in range(5000000)}

for i in range(5):
	x = random.randint(0, 5000000)
	
	startZeit = time.time()
	if x in liste:
		print(f"List: {time.time() - startZeit}")
		
	startZeit = time.time()
	if x in dictionary:
		print(f"Dict: {time.time() - startZeit}")

print("---")
