# Dictionaries
# Auch als Hashmap oder Hashtable bekannt
# "Wörterbuch" besteht aus mehreren Einträgen mit Schlüsselwörtern denen jeweils Werte zugeordnet sind.

# Leeres Dictionary erstellen
dictionaryLeer = {}
print(dictionaryLeer)
print(type(dictionaryLeer))

# {Schlüsselwort: Wert}		{Mitarbeiternummer: [Name, Geburtsdatum, Gehalt]}
mitarbeiter = {1: ["Felix", "1988-09-21", 90000], 2: ["Mareike", "1992-11-24", 59000]}
print(mitarbeiter)
print(mitarbeiter.keys())
print(mitarbeiter.values())

# Neuen Eintrag hinzufügen
mitarbeiter[3] = ["Olivia", "1988-03-19", 45000]
print(mitarbeiter)

# Bestehenden Wert verändern
mitarbeiter[3][2] = 52000	# Herzlichen Glückwunsch zur Gehaltserhöhung
print(mitarbeiter)

# Wert eines Schlüsselwortes auslesen
print(mitarbeiter.get(3))
print(mitarbeiter[3])		# gibt Fehlermeldung zurück wenn Schlüsselwort nicht gefunden wurde
print(mitarbeiter.get(5))	# .get() Funktion gibt None zurück wenn Schlüsselwort nicht gefunden wurde

# Eintrag löschen
del mitarbeiter[1]
print(mitarbeiter)

# prüfen ob Dictionary einen bestimmten Wert enthält
print(1 in mitarbeiter)
print(3 in mitarbeiter)

# Schleifendurchlauf durch alle Elemente
for schluesselwort, wert in mitarbeiter.items():
	print(f"Schlüsselwort: {schluesselwort} - Wert: {wert}")
