# String Variablen definieren und abfragen
testString = "Hello World =)"
print(type(testString), testString)
testString2 = 'Das ist ein anderer Text.'
print(type(testString2), testString2)

# Escape Zeichen
print("Ich möchte gern ein \" in meinem Text haben.")

# Zeilenumbruch
print("Ich möchte gern \nin zwei Zeilen schreiben.")

# Verketten
print("Will" + "kom" + "men =)")

# String Formatierung
wer = "Peter"
wieViele = 3
print("{1} hat {0} Äpfel gekauft.".format(wieViele, wer))
print(f"{wer} hat {wieViele} Äpfel gekauft.")

# Zeichenanzahl in einem String
print(len(testString))

# Prüfen ob String aus Zahl(en) oder Buchstabe(n) besteht
print(testString.isalpha())
print("abc".isalpha())
print(testString.isalnum())
print("123".isalnum())

# Großschreibung / Kleinschreibung
print(testString.lower())
print(testString.upper())

# String zerteilen
print(testString.split("l"))
print("1, 2, 3, 4, 5".split(", "))

# Teilstring ersetzen
print(testString.replace("World", "WRLD"))

# Prüfen ob Teilstring Bestandteil von String ist
testString = "Hello World =)"
if "World" in testString:
	print(f"World ist ein Bestandteil von: {testString}.")

# Zeichen an bestimmter Position
print(testString[6])
print(testString[0])
print(testString[-1])
print(testString[12:15])	# [Start (einschließlich) : Ende (ausschließlich)]
